/********************************************************
*  J[OtBbNLCD(132131hbgjpCu
*     iZY-FGD1442701V1p, PIC18p)
*	lcd_Init();		// 
*	lcd_Clear();		// Sʏ
*	lcd_Pixel();		// 1hbg\
*	lcd_Char();		// ANK\
*	lcd_Str();		// ANK\
*	lcd_Line();		// `
*	lcd_Circle();		// ~`
*********************************************************/
#include <p18f26j11.h>
#include "colorlcd_lib18j.h"
#include "ASCII12dot.h"		//ASCII 12x12dot
#include <delays.h>

/********************************
* R}hAf[^o͊֐ 
*********************************/
void lcd_cmd(unsigned char cmnd){
	LCD_DIO = 0;				// CD Command 
	LCD_CS = 0;				// CS Low
	LATB = cmnd;				// Data Out
	LCD_WR = 0;				// WR out
	Delay1TCY();				// 1cycle
	LCD_WR = 1;				// WR High
	LCD_DIO = 1;				// CD High
	LCD_CS = 1;				// CS High
}
void lcd_data(unsigned char data){
	LCD_DIO = 1;				// CD Data
	LCD_CS = 0;				// CS Low
	LATB = data;				// Data Out
	LCD_WR = 0;				// WR Pulse
	Delay1TCY();				// 1cycle
	LCD_WR = 1;				// WR High
	LCD_CS = 1;				// CS High
}

/****************************
* LCD֐  
*****************************/
void lcd_Init(void){
	LCD_CS = 1;				// CS High
	LCD_WR = 1;				// WR High
	LCD_RD = 1;				// RD High
	LCD_RST = 1;				// Reset off
	delay_ms(10);
	LCD_RST = 0;				
	delay_ms(1);				// Zbgo
	LCD_RST = 1;
	delay_ms(120);

	lcd_cmd(SLPOUT);			// X[v
	delay_ms(120);			// EFCNAbv҂
	lcd_cmd(VCOM4L);			//
	lcd_data(0x40);
	lcd_data(0x03);
	lcd_data(0x1A);
	lcd_cmd(NVCTR1);			//
	lcd_data(0x60);
	lcd_cmd(VMOFCTR);			//
	lcd_data(0x90);
	delay_ms(20);
	lcd_cmd(FRMCTR1);			//Frame Rate in normal mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	lcd_cmd(FRMCTR2);			//Frame Rate in Idle mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	lcd_cmd(FRMCTR3);			//Frame Rate in Partial mode
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	lcd_data(0x04);
	lcd_data(0x25);
	lcd_data(0x18);
	lcd_cmd(INVCTR);			//Display Inversion normal
	lcd_data(0x03);
	lcd_cmd(DISSET5);			//Gate overlap
	lcd_data(0x15);
	lcd_data(0x02);
	lcd_data(PWCTR1);			//Power control
	lcd_data(0x02);			//VRH=4.7V IB=1uA
	lcd_data(0x70);
	lcd_cmd(PWCTR2);			//Power control
	lcd_data(0x07);			//VGHH=6*VCI
	lcd_cmd(PWCTR3);			//Power control Normal mode
	lcd_data(0x01);			//Small
	lcd_data(0x01);			//BCLK/1 BCLK/2
	lcd_cmd(PWCTR4);			//Power control Idle mode
	lcd_data(0x02);			//Medium
	lcd_data(0x07);			//BCL/4 BCLK/16
	lcd_cmd(PWCTR5);			//Power control Partial mode
	lcd_data(0x02);			//Medeum
	lcd_data(0x04);			//BCLK/2 BCLK/4
	lcd_cmd(PWCTR6);			//Power control Partioal+Idle
	lcd_data(0x11);			//
	lcd_data(0x17);
	lcd_cmd(VMCTR1);			//VCOM control
	lcd_data(0x3C);			//VCOMH=4.0
	lcd_data(0x4F);			//VCOML=-0.525
	lcd_cmd(MADCTL);			//Memory Data Access H refresh
	lcd_data(0x08);
	lcd_cmd(COLMOD);
	lcd_data(0x05);			// Color 16bit mode
	lcd_cmd(GAMCTRP1);		//Gamma correction +pole
	lcd_data(0x06);
	lcd_data(0x0E);
	lcd_data(0x05);
	lcd_data(0x20);
	lcd_data(0x27);
	lcd_data(0x23);
	lcd_data(0x1C);
	lcd_data(0x21);
	lcd_data(0x20);
	lcd_data(0x1C);
	lcd_data(0x26);
	lcd_data(0x2F);
	lcd_data(0x00);
	lcd_data(0x03);
	lcd_data(0x00);
	lcd_data(0x24);
	lcd_cmd(GAMCTRN1);		//Gamma correction -pole
	lcd_data(0x06);
	lcd_data(0x10);
	lcd_data(0x05);
	lcd_data(0x21);
	lcd_data(0x27);
	lcd_data(0x22);
	lcd_data(0x1C);
	lcd_data(0x21);
	lcd_data(0x1F);
	lcd_data(0x1D);
	lcd_data(0x27);
	lcd_data(0x2F);
	lcd_data(0x05);
	lcd_data(0x03);
	lcd_data(0x00);
	lcd_data(0x3F);
	lcd_cmd(DISPON);			// \I
	delay_ms(10);
}
/***************************
* ʏ֐
* pFw肠
* ʂ132~130hbg
****************************/
void lcd_Clear(unsigned int Color){
	int i;

	lcd_cmd(CASET);				// RAhXZbg
	lcd_data(0);
	lcd_data(0);					// 0Ԓn
	lcd_data(0);
	lcd_data(ENDCOL+3);				// ʑS
	lcd_cmd(RASET);				// RawAhXZbg
	lcd_data(0);					
	lcd_data(0);					// 0Ԓn
	lcd_data(0);
	lcd_data(ENDPAGE+2);			// ʑS
	lcd_cmd(RAMWR);				// RAM݃R}h
	// 16rbgJ[œhԂ
	for(i=0; i<(ENDCOL+4)*(ENDPAGE+3); i++){
		lcd_data(Color >> 8);
		lcd_data(Color);
	}
}
/***********************************
*  PsNZ\֐
*  W(0,0)-(128,128)  
***********************************/
void lcd_Pixel(int Xpos, int Ypos, unsigned int Color){
	/* AhX͈̓`FbN͈͊OȂ牽Ȃ */
	if((Xpos<=ENDCOL) && (Ypos<=ENDPAGE)){
		Xpos += 2;				// AhX␳
		Ypos += 1;
		lcd_cmd(RASET);			// siRAW)AhXZbg
		lcd_data(0);	
		lcd_data(Ypos);			// JnAhX
		lcd_data(0);
		lcd_data(Ypos);			// IAhX
		lcd_cmd(CASET);			// iCOLUM)AhXZbg
		lcd_data(0);	
		lcd_data(Xpos);			// JnAhX
		lcd_data(0);	
		lcd_data(Xpos);			// IAhX
		lcd_cmd(RAMWR);			// 1sNZ
		// 16rbgJ[ŏ
		lcd_data((unsigned char)(Color >> 8));
		lcd_data((unsigned char)Color);
	}
}
/***************************
*  `֐
***************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void lcd_Line(int x0, int y0, int x1, int y1, unsigned int Color)
{
	int steep, t;
	int deltax, deltay, error;
	int x, y;
	int ystep;
	
	y0=ENDPAGE-y0;					// YW]
	y1=ENDPAGE-y1;
	/// ̑傫ق߂
	steep = (abs(y1 - y0) > abs(x1 - x0));
	/// A̓ւ
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}
	if(x0 > x1) {
		t = x0; x0 = x1; x1 = t;
		t = y0; y0 = y1; y1 = t;
	}
	deltax = x1 - x0;					// XvZ	
	deltay = abs(y1 - y0);
	error = 0;
	y = y0;
	/// XŃXebv̐؂ւ
	if(y0 < y1) ystep = 1; else ystep = -1;
	/// _ŕ`
	for(x=x0; x<=x1; x++) {
		if(steep) lcd_Pixel(y,x,Color); else lcd_Pixel(x,y,Color);
		error += deltay;
		if((error << 1) >= deltax) {
			y += ystep;
			error -= deltax;
		}
	}
}
/*************************************
*  ~`֐
*  S_Ɣaw
*  (FussỹASYgp)
**************************************/
void lcd_Circle(int x0, int y0, int r, unsigned short color)
{
	int x = r;
	int y = 0;
	int F = -2 * r + 3;
	
	while(x >= y){
		lcd_Pixel(x0+x, y0+y, color);
		lcd_Pixel(x0-x, y0+y, color);		
		lcd_Pixel(x0+x, y0-y, color);
		lcd_Pixel(x0-x, y0-y, color);		
		lcd_Pixel(x0+y, y0+x, color);
		lcd_Pixel(x0-y, y0+x, color);		
		lcd_Pixel(x0+y, y0-x, color);
		lcd_Pixel(x0-y, y0-x, color);
		if(F >= 0){
			x--;
			F -= 4 * x;
		}
		y++;
		F += 4 * y + 2;
	}
}

/*****************************************
*  ASCII\֐ 12x12hbg
*  128/12=10/s@128/14=9s
*  (0, 0) - (9, 8)͈̔
*  X\ʒu4hbgEփVtg
******************************************/
void lcd_Char(char colum, char line, unsigned char letter, unsigned int Color1, unsigned int Color2){
	unsigned char j, i, Mask;

	if((colum < XChar) && (line < YLine)){							// ͈̓`FbN
		// ANK\ó@3oCg2C6JԂ
		for(j=0; j<6; j++){
			// 8hbgA̕\
			Mask = 0x80;
			for(i=0; i<8; i++){
				// PCڑO8hbg\
				if((ANKFont[letter][j*3] & Mask) != 0)
					lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color1);
				else
					lcd_Pixel(colum*12+i+4, line*14+j*2+1, Color2); 		//wiF
				// 2Cڌ㔼8hbg\
				if((ANKFont[letter][j*3+2] & Mask) != 0)
					lcd_Pixel(colum*12+i+8, line*14+j*2+2, Color1);
				else
					lcd_Pixel(colum*12+i+8, line*14+j*2+2, Color2); 	//wiF
				Mask = Mask >> 1;
			}
			// 4hbg\
			Mask = 0x80;
			// 1Cڌ㔼4hbg\
			for(i=0; i<4; i++){
				if((ANKFont[letter][j*3+1] & Mask) != 0)
					lcd_Pixel(colum*12+i+12, line*14+j*2+1, Color1);
				else
					lcd_Pixel(colum*12+i+12, line*14+j*2+1, Color2);	 //wiF
				Mask = Mask >> 1;
			}
			// 2CڑO4hbg\
			for(i=4; i<8; i++){
				if((ANKFont[letter][j*3+1] & Mask) != 0)
					lcd_Pixel(colum*12+i, line*14+j*2+2, Color1);
				else
					lcd_Pixel(colum*12+i, line*14+j*2+2, Color2); 	//wiF
				Mask = Mask >> 1;
			}							
		}
	}
}
/******************************
*   `֐
*   1616sŎw
******************************/
void lcd_Str(char colum, char line, char *s, unsigned int Color1, unsigned int Color2)
{
    	while (*s){
		lcd_Char(colum++, line, *s++, Color1, Color2);
		if(colum >= XChar){
			line++;
			colum = 0;
			if(line >= YLine)
				line = 0;
		}
	}
}
/*********************************************************
* C[W\֐
*@ BMPf[^͍EցA֊i[Ă
*   128~128/8=2koCg/
*   OtBbNF(Color1)ƔwiF(Color2)w
**********************************************************/
void lcd_Image(rom unsigned char *ptr, unsigned short Color1, unsigned Color2)
{
	unsigned char Mask;
	short i, vline, colum;

	ptr += 2032;							// |C^Ō̃Cɂ炷
	for(vline=0; vline<128; vline++){		// Ŝ128C
		for(colum=0; colum<16; colum++){	// 8x16=128hbgƂ
			Mask = 0x80;					// ʂEփVtg
			for(i=0; i<8; i++){			// 1oCg
				if(*ptr & Mask)			// rbg`FbN
					lcd_Pixel(colum*8+i, vline, Color1);
				else
					lcd_Pixel(colum*8+i, vline, Color2);					
				Mask = Mask >> 1;			// rbgʒuVtg
			} 
			ptr++;						// C̎̃f[^
		}
		ptr -= 32;						// ЂƂ̃Cֈړ
	}
}
/******************************************
* x֐
******************************************/	
/** 1msec Delay SubFunction at 8MIPS ***/
void delay_ms(int time){
	while(time > 0){
		Delay100TCYx(80);		// 1msec
		time--;
	}
}

